Bug 1283764 - Use of uninitialized value in numeric eq (==) at /usr/share/perl5/vendor_perl/File/Tail.pm line 391
Summary: Use of uninitialized value in numeric eq (==) at /usr/share/perl5/vendor_perl...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: perl-File-Tail
Version: 32
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Tom "spot" Callaway
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2015-11-19 18:44 UTC by Harald Reindl
Modified: 2020-11-27 01:22 UTC (History)
1 user (show)

Fixed In Version: perl-File-Tail-1.3-19.fc32 perl-File-Tail-1.3-19.fc33
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-11-27 01:11:57 UTC
Type: Bug


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
CPAN 109163 0 None None None Never

Description Harald Reindl 2015-11-19 18:44:56 UTC
Nov 19 12:20:09 testserver perl: Use of uninitialized value in numeric eq (==) at /usr/share/perl5/vendor_perl/File/Tail.pm line 391

i guess mailgraph triggers that bug

[root@testserver:~]$ rpm -q --file /usr/share/perl5/vendor_perl/File/Tail.pm
perl-File-Tail-1.3-1.fc23.noarch

Comment 1 Harald Reindl 2016-02-09 14:52:49 UTC
i think 3 months should be enough to fix obvious bugs in a GA release

Comment 2 Tom "spot" Callaway 2016-02-11 20:46:01 UTC
With respect, I do not see a patch from you and the fix is non-obvious, which is why I opened an upstream ticket 3 months ago.

Comment 3 Harald Reindl 2016-02-11 21:11:47 UTC
yeah - there is not patch from me - so what - did i change Fedora to trigger this with a non-existing QA to make whatever change to a GA release?

Comment 4 Fedora End Of Life 2017-07-25 19:31:53 UTC
This message is a reminder that Fedora 24 is nearing its end of life.
Approximately 2 (two) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 24. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '24'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 24 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Comment 5 Fedora End Of Life 2017-08-08 12:26:16 UTC
Fedora 24 changed to end-of-life (EOL) status on 2017-08-08. Fedora 24 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Comment 6 Tom "spot" Callaway 2017-08-08 18:34:35 UTC
I think this is fixed in 1.3-7.fc25. Please test the update that is incoming to confirm.

Comment 7 Fedora Update System 2017-08-08 18:36:05 UTC
perl-File-Tail-1.3-7.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-f475d1d0a5

Comment 8 Fedora Update System 2017-08-12 01:27:49 UTC
perl-File-Tail-1.3-7.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-b25ad12e0c

Comment 9 Fedora Update System 2017-08-13 04:03:12 UTC
perl-File-Tail-1.3-7.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-f475d1d0a5

Comment 10 Harald Reindl 2017-08-13 13:10:45 UTC
it's not

[root@testserver:~]$ cat messages
Aug 13 14:32:35 testserver systemd: Starting Cleanup of Temporary Directories...
Aug 13 14:32:36 testserver systemd: Started Cleanup of Temporary Directories.
Aug 13 14:39:25 testserver perl: Use of uninitialized value in numeric eq (==) at /usr/share/perl5/vendor_perl/File/Tail.pm line 392.

[root@testserver:~]$ rpm -qa | grep -i perl | grep -i tail
perl-File-Tail-1.3-7.fc25.noarch

[root@testserver:~]$ rpm -q --info perl-File-Tail-1.3-7.fc25.noarch
Name        : perl-File-Tail
Version     : 1.3
Release     : 7.fc25
Architecture: noarch
Install Date: Sat Aug 12 19:12:15 2017
Group       : Development/Libraries
Size        : 39612
License     : GPL+ or Artistic
Signature   : RSA/SHA256, Wed Aug  9 03:29:54 2017, Key ID 4089d8f2fdb19c98
Source RPM  : perl-File-Tail-1.3-7.fc25.src.rpm
Build Date  : Tue Aug  8 19:51:35 2017
Build Host  : buildvm-armv7-05.arm.fedoraproject.org
Relocations : (not relocatable)
Packager    : Fedora Project
Vendor      : Fedora Project
URL         : http://search.cpan.org/dist/File-Tail/
Summary     : Perl extension for reading from continously updated files

Comment 11 Harald Reindl 2017-09-26 09:02:51 UTC
the same in F26 with updates-testing enabled, release-number seemes to be lower in F26

Sep 25 19:43:09 testserver perl[543]: Use of uninitialized value in numeric eq (==) at /usr/share/perl5/vendor_perl/File/Tail.pm line 391

[root@testserver:~]$ rpm -q --info perl-File-Tail
Name        : perl-File-Tail
Version     : 1.3
Release     : 4.fc26
Architecture: noarch
Install Date: Do 21 Sep 2017 15:23:11 CEST
Group       : Development/Libraries
Size        : 39518
License     : GPL+ or Artistic
Signature   : RSA/SHA256, So 12 Feb 2017 00:19:42 CET, Key ID 812a6b4b64dab85d
Source RPM  : perl-File-Tail-1.3-4.fc26.src.rpm
Build Date  : Sa 11 Feb 2017 14:07:21 CET
Build Host  : buildvm-aarch64-07.arm.fedoraproject.org
Relocations : (not relocatable)
Packager    : Fedora Project
Vendor      : Fedora Project
URL         : http://search.cpan.org/dist/File-Tail/
Summary     : Perl extension for reading from continously updated files
Description :
The primary purpose of File::Tail is reading and analysing log files
while they are being written, which is especially useful if you are
monitoring the logging process with a tool like Tobias Oetiker's MRTG.

Comment 12 Fedora End Of Life 2017-11-16 19:31:43 UTC
This message is a reminder that Fedora 25 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 25. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '25'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 25 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Comment 13 Fedora End Of Life 2017-12-12 11:10:22 UTC
Fedora 25 changed to end-of-life (EOL) status on 2017-12-12. Fedora 25 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Comment 14 Harald Reindl 2019-08-26 10:35:58 UTC
how many years can it take to fix such a bug?

Aug 26 12:33:01 testserver perl[629]: Use of uninitialized value in numeric eq (==) at /usr/share/perl5/vendor_perl/File/Tail.pm line 392

Comment 15 Tom "spot" Callaway 2019-08-27 14:36:53 UTC
Based on the total lack of upstream activity, it may never be fixed.

Comment 16 Ben Cotton 2019-10-31 18:54:38 UTC
This message is a reminder that Fedora 29 is nearing its end of life.
Fedora will stop maintaining and issuing updates for Fedora 29 on 2019-11-26.
It is Fedora's policy to close all bug reports from releases that are no longer
maintained. At that time this bug will be closed as EOL if it remains open with a
Fedora 'version' of '29'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 29 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 17 Ben Cotton 2020-04-30 20:49:23 UTC
This message is a reminder that Fedora 30 is nearing its end of life.
Fedora will stop maintaining and issuing updates for Fedora 30 on 2020-05-26.
It is Fedora's policy to close all bug reports from releases that are no longer
maintained. At that time this bug will be closed as EOL if it remains open with a
Fedora 'version' of '30'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 30 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 18 Fedora Admin user for bugzilla script actions 2020-06-03 02:53:26 UTC
This package has changed maintainer in the Fedora.
Reassigning to the new maintainer of this component.

Comment 19 Harald Reindl 2020-07-24 23:09:14 UTC
big cinema, 5 years later still unfixed

Comment 20 Ben Cotton 2020-11-03 14:57:18 UTC
This message is a reminder that Fedora 31 is nearing its end of life.
Fedora will stop maintaining and issuing updates for Fedora 31 on 2020-11-24.
It is Fedora's policy to close all bug reports from releases that are no longer
maintained. At that time this bug will be closed as EOL if it remains open with a
Fedora 'version' of '31'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 31 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 21 Harald Reindl 2020-11-03 15:00:40 UTC
i am tired about that thoughtless "end of life" actions when damned bugs don't get fixed over *five years*

Comment 22 Tom "spot" Callaway 2020-11-03 15:38:25 UTC
This is my favorite bug, because I get to see it once a year.

Harald, I cannot reproduce this locally, because the only person who can trigger it is you. The program you claim triggers the bug (mailgraph) depends on a working mailserver using syslog, which I do not have (either, a mailserver or a system using syslog). It also hasn't been updated since 2007.

File::Tail has been abandoned since 2015. 

So, unless you can assist me with a reproduction case that does not involve installing a mailserver and an archaic logging infrastructure, this bug will be closed WONTFIX.

Comment 23 Harald Reindl 2020-11-03 17:37:30 UTC
i am not a perl programmer, but "Use of uninitialized value in numeric eq (==) at /usr/share/perl5/vendor_perl/File/Tail.pm line 391" in PHP would likely cost me one line before to just make sure what ever is used in 391 is initalized if it's not already

Comment 24 Tom "spot" Callaway 2020-11-03 22:53:52 UTC
Be grateful you are not a perl programmer. :)

It seems the values can be initialized but NULL and trigger this, but I cannot make it happen locally. The comment block directly above the line of code says:

# If the file was changed the same second as it was last read,
# we only reopen it if it's length has changed. The alternative is that
# sometimes, files would be reopened needlessly, and with reset_tail
# set to -1, we would see the whole file again.
# Of course, if the file was removed the same second as when it was
# last read, and replaced (within that second) with a file of equal
# length, we're out of luck. I don't see how to fix this.

Which leads me to believe their algorithm is totally wrong.

The challenge in trying to debug this is that I simply cannot reproduce it. I put in code that I thought would fix the issue, but you reported that it did not. Everything seems to be initialized and the entire existing test suite passes. I had hoped upstream would be able to provide insight (5 years ago), but they have clearly abandoned the effort.

Given all of that, I am hesitant to make additional changes to the algorithm logic without a reproducer. Are you still actively using a setup that could reproduce this?

Comment 25 Tom "spot" Callaway 2020-11-03 23:19:21 UTC
I've looked at this again with fresh eyes and I _think_ I see the issue and a potential fix, but it would be really helpful to have a reproducer (even if the reproducer is me making a scratch build and you testing it on your setup where the problem occurs).

Comment 26 Harald Reindl 2020-11-04 01:50:05 UTC
i see that on any machine running postfix and mailgrpah a few minutes after each and every reboot, that's why it's so annyoing when you filter fopr warning/fail/error over a whole cluster

Comment 27 Tom "spot" Callaway 2020-11-04 15:16:12 UTC
Okay, please test this build and let me know if anything changes:

https://koji.fedoraproject.org/koji/taskinfo?taskID=54919576

Comment 28 Harald Reindl 2020-11-06 11:39:19 UTC
this is a F33 build and production servers will see F33 not before 2-4 months after release

Comment 29 Tom "spot" Callaway 2020-11-06 16:26:55 UTC
Please tell me what target you need in order to test this fix.

Comment 30 Harald Reindl 2020-11-06 16:37:28 UTC
Fedora 32 - that's why i updated "Version" of this bugreport :-)

Comment 31 Tom "spot" Callaway 2020-11-09 15:36:23 UTC
Fedora 32 scratch build: https://koji.fedoraproject.org/koji/taskinfo?taskID=55243290

Comment 32 Harald Reindl 2020-11-13 14:00:43 UTC
2020-11-13T14:46:34+0100 SUBDEBUG Upgrade: perl-File-Tail-1.3-18.fc32.noarch

Nov 13 14:47:47 thx1138 systemd[1]: Stopping Mailgraph...
Nov 13 14:47:47 thx1138 systemd[1]: Stopped Mailgraph.
Nov 13 14:47:47 thx1138 systemd[1]: mailgraph.service: Consumed 7.849s CPU time.
Nov 13 14:47:47 thx1138 systemd[1]: Starting Mailgraph...
Nov 13 14:47:47 thx1138 systemd[1]: Started Mailgraph.
Nov 13 14:57:50 thx1138 perl[1720899]: Use of uninitialized value in numeric eq (==) at /usr/share/perl5/vendor_perl/File/Tail.pm line 391.

Comment 33 Tom "spot" Callaway 2020-11-13 16:03:59 UTC
Alright. Please try -19:

https://koji.fedoraproject.org/koji/taskinfo?taskID=55535461

Comment 34 Harald Reindl 2020-11-16 21:35:28 UTC
i wouldn't swear at the moment but it pretty sure looks like perl-File-Tail-1.3-19.fc32.noarch is fixing the issue

Comment 35 Fedora Update System 2020-11-18 20:49:51 UTC
FEDORA-2020-503b26ba4f has been submitted as an update to Fedora 32. https://bodhi.fedoraproject.org/updates/FEDORA-2020-503b26ba4f

Comment 36 Fedora Update System 2020-11-19 01:56:11 UTC
FEDORA-2020-503b26ba4f has been pushed to the Fedora 32 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2020-503b26ba4f`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-503b26ba4f

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 37 Fedora Update System 2020-11-19 02:19:46 UTC
FEDORA-2020-66c34e1f1e has been pushed to the Fedora 33 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2020-66c34e1f1e`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-66c34e1f1e

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 38 Fedora Update System 2020-11-27 01:11:57 UTC
FEDORA-2020-503b26ba4f has been pushed to the Fedora 32 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 39 Fedora Update System 2020-11-27 01:22:42 UTC
FEDORA-2020-66c34e1f1e has been pushed to the Fedora 33 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.